function [ output_vector,totalOutput ] = SelectUpdatedNumberNoSeg( input_vector,pqrst,input_a )
averageDiff=600;
maxl=floor(length(input_vector)/averageDiff);
S1_ind_test={};
S1_value_test={};
S1_max={};
for jj=1:maxl
    S1_ind_test{jj}=[(jj-1)*averageDiff+1:(jj)*averageDiff];
    S1_value_test{jj}=input_vector(S1_ind_test{jj});
    S1_max{jj}=max(S1_value_test{jj});
end


dwtmode('sym');
v10_features=zeros(pqrst,90);
selected_S1={};
% A=input_a;
% m_RR        = round(mean(diff(A(:,1))));             % mean value of RR intervals
% sd_RR       = round(std(diff(A(:,1))));              % standard deviation (SD) value of RR intervals
% mean_IntS1  = round(mean(A(:,2)-A(:,1)));            % mean value of S1 intervals
% sd_IntS1    = round(std(A(:,2)-A(:,1)));             % SD value of S1 intervals
% mean_IntS2  = round(mean(A(:,4)-A(:,3)));            % mean value of S2 intervals
% sd_IntS2    = round(std(A(:,4)-A(:,3)));             % SD value of S2 intervals
% mean_IntSys = round(mean(A(:,3)-A(:,2)));            % mean value of systole intervals
% sd_IntSys   = round(std(A(:,3)-A(:,2)));             % SD value of systole intervals
% mean_IntDia = round(mean(A(2:end,1)-A(1:end-1,4)));  % mean value of diastole intervals
% sd_IntDia   = round(std(A(2:end,1)-A(1:end-1,4)));   % SD value of diastole intervals
%
% feature_ind=[m_RR sd_RR  mean_IntS1 sd_IntS1  mean_IntS2 sd_IntS2  mean_IntSys sd_IntSys  mean_IntDia sd_IntDia];

for(jj=1:pqrst)
    [max1, ind1]=max([S1_max{:}]);
    selected_S1{jj}=S1_value_test{ind1};
    
    S1_max{ind1}=0;
    
    mean1=sum(selected_S1{jj})/size(selected_S1{jj},1);
    selected_S1{jj}=selected_S1{jj}-mean1*ones(size(selected_S1{jj},1),1);
    
    [c,l]=wavedec(selected_S1{jj},4,'db8');
    v1=detcoef(c,l,3);v2=detcoef(c,l,4);v3=appcoef(c,l,'db8',4);
    aux=[v1(1:min(40,size(v1,1)))' v2(1:min(25,size(v2,1)))' v3(1:min(25,size(v3,1)))'] ;
    v10_features(jj,1:size(aux,2))=aux;
end

means=sum(v10_features,2)/pqrst;
[smeans,si]=sort(means);
v10_featuresu=v10_features(si,:);

output_vector=v10_featuresu;
totalOutput=[output_vector(:)];
end