function [pkVals,peakInds] = basicFindPeaks(ypp)

len0 = length(ypp);
sel = (max(ypp)-min(ypp))/4;
ypp = ypp(:);
diffy = diff(ypp);
diffy(diffy == 0) = -eps;
ind = find(diffy(1:end-1).*diffy(2:end) < 0)+1;

y = [ypp(1);ypp(ind);ypp(end)];
ind = [1;ind;len0];
minVal = min(y);
prevMin = minVal;

len = length(y);

if len > 2
    cVal = minVal;
	foundPeak = false;    
    signDiffy = sign(diff(y(1:3)));
    if signDiffy(1) <= 0 
        if signDiffy(1) == signDiffy(2)
            y(2) = [];
            ind(2) = [];
            len = len-1;
        end
    else 
        if signDiffy(1) == signDiffy(2)
            y(1) = [];
            ind(1) = [];
            len = len-1;
        end
    end
    if y(1) >= y(2)
        ii = 0;
    else
        ii = 1;
    end
    maxNPeaks = ceil(len/2);
    locs = zeros(maxNPeaks,1);
    pkVal = zeros(maxNPeaks,1);
    cInd = 1;
    while ii < len
        ii = ii+1; 
        if foundPeak
            cVal = minVal;
            foundPeak = false;
        end
        if y(ii) > cVal && y(ii) > prevMin + sel
            cLoc = ii;
            cVal = y(ii);
        end        
        if ii == len
            break;
        end        
        ii = ii+1;
        if ~foundPeak && cVal > sel + y(ii)
            foundPeak = true; 
            prevMin = y(ii);
            locs(cInd) = cLoc; 
            pkVal(cInd) = cVal;
            cInd = cInd+1;
        elseif y(ii) < prevMin
            prevMin = y(ii);
        end
    end       
    if y(end) > cVal && y(end) > prevMin + sel
        locs(cInd) = len;
        pkVal(cInd) = y(end);
        cInd = cInd + 1;
    elseif ~foundPeak && cVal > minVal 
        locs(cInd) = cLoc;
        pkVal(cInd) = cVal;
        cInd = cInd + 1;
    end
    
    
    % Create output
    if cInd > 1
        peakInds = ind(locs(1:cInd-1));
        pkVals = pkVal(1:cInd-1);
    else
        peakInds = [];
        pkVals = [];
    end
else
    [pkVals,yInd] = max(y);
    if pkVals > minVal + sel
        peakInds = ind(yInd);
    else
        pkVals = [];
        peakInds = [];
    end
end