function featureVector = challenge(recordName)
[PCG, Fs1]         = audioread(recordName);  % load data
sr = 1000;
PCG_resampled      = resample(PCG,sr,Fs1); % resample to springer_options.audio_Fs (1000 Hz)
N=60; 
Wn = 45*2/sr;
b1 = fir1(N,Wn,'low',hamming(N+1));
Wn = [45*2/sr, 80*2/sr];
b2 = fir1(N,Wn,hamming(N+1));
Wn = [200*3/sr, 200*4/sr];
b3 = fir1(N,Wn,hamming(N+1));
Wn = 200*4/sr;
b4 = fir1(N,Wn,'high',hamming(N+1));
Wn = [200*2/sr, 200*3/sr];
b5 = fir1(N,Wn,hamming(N+1));
Indexes=[1 2 3];
PCG1 = filtfilt(b1,1,PCG_resampled);
[~,featuresA1]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG1,Indexes);
PCG2 = filtfilt(b2,1,PCG_resampled);
[~,featuresA2]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG2,Indexes);
PCG3 = filtfilt(b3,1,PCG_resampled);
[~,featuresA3]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG3,Indexes);
PCG4 = filtfilt(b4,1,PCG_resampled);
[~,featuresA4]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG4,Indexes);
PCG5 = filtfilt(b5,1,PCG_resampled);
[~,featuresA5]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG5,Indexes);
[~,featuresA]=findPCGpeaksNewFeatures2IndexDiffsEntropyFFT(PCG_resampled,Indexes);

pqrst=10;
% featureVector1=zeros(1,pqrst*90);
[~,featureVector1] = SelectUpdatedNumberNoSeg(PCG_resampled,pqrst,[]); %this is in the ECG folder
featureVector=[featureVector1',featuresA,featuresA1,featuresA2,featuresA3,featuresA4,featuresA5];
% global allFeaturesValidation
% allFeaturesValidation=[allFeaturesValidation;featureVector];
% classifyResult=combineEnsemblesLogitSAlocal(featureVector);
%classifyResult=combineEnsemblesLogitSA(featureVector);