function predictions=prepareSignalsForNetPrediction(signals,SomeFeatures,net1A,net2A,net1,net2,sn,meanDataSignals,stdDataSignals)

Nq=4;
N = Nq*1e4;
% miniBatchSizes=[128];
% miniBatchSize=miniBatchSizes(1);
maxVal=1e3;
SomeFeatures(SomeFeatures>maxVal)=maxVal;
miniBatchSize = 128;
coeff1=10;
dataAllsignalsMat=zeros(length(signals),N);
trainSize=length(signals);
for i=1:length(signals)
    cfeature=signals{i};
    if length(cfeature)<N
        cfeature=[cfeature;cfeature];
        while length(cfeature)<N
            cfeature=[cfeature;cfeature];
        end
    end
    dataAllsignalsMat(i,:)=cfeature(1:N);
end
% meanDataSignals=mean(dataAllsignalsMat);
% stdDataSignals=std(dataAllsignalsMat,1);
dataAllsignalsMat = (dataAllsignalsMat-meanDataSignals)./(stdDataSignals+1e-10);
dataAllsignalsMat(isnan(dataAllsignalsMat))=0;
dataAllsignalsMat(dataAllsignalsMat>1e10)=1e10;

scat_features = cell(trainSize,1);
tmp = featureMatrix(sn,dataAllsignalsMat(:,:)')*coeff1;
for itr=1:trainSize
    scat_features{itr,1} =tmp(:,:,itr);
end
SomeFeatures(isinf(SomeFeatures))=maxVal;
SomeFeatures(isnan(SomeFeatures))=0;
[inputSize,~] = size(scat_features{1});
scat_features_Array=zeros(inputSize,size(scat_features{1},2),length(scat_features));
for i=1:size(scat_features_Array,3)
    scat_features_Array(:,:,i)=scat_features{i};
end

if rem(trainSize,128)>0
    noSamplesToAdd=128-rem(trainSize,128);
end

scat_features_ArrayAll=zeros(inputSize,size(scat_features{1},2),length(scat_features)+noSamplesToAdd);
scat_features_ArrayAll(:,:,1:length(scat_features))=scat_features_Array;
scat_features_Array=scat_features_ArrayAll;
SomeFeatures=[SomeFeatures;zeros(noSamplesToAdd,size(SomeFeatures,2))];

dsXVal1 = arrayDatastore(scat_features_Array,'IterationDimension',3);
dsAnglesVal1 = arrayDatastore(SomeFeatures);
dsVal1 = combine(dsXVal1,dsAnglesVal1);

mbq = minibatchqueue(dsVal1,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatchTest,...
    'MiniBatchFormat',{'CTB','CB'});
predictions2 = modelPredictionsTest(net2,mbq);
predictions2=predictions2(1:trainSize);

mbq = minibatchqueue(dsVal1,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatchTest,...
    'MiniBatchFormat',{'CTB','CB'});
predictions1 = modelPredictionsTest(net1,mbq);
predictions1=predictions1(1:trainSize);





mbq = minibatchqueue(dsVal1,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatchTest,...
    'MiniBatchFormat',{'CTB','CB'});
predictions1A = modelPredictions2Test(net1A,mbq);
predictions1A=predictions1A(1:trainSize);

mbq = minibatchqueue(dsVal1,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatchTest,...
    'MiniBatchFormat',{'CTB','CB'});
predictions2A = modelPredictions2Test(net2A,mbq);
predictions2A=predictions2A(1:trainSize);

predictions=predictions1+predictions2+predictions1A+predictions2A;
predictions=predictions/4;
predictions=predictions(:);