function [savednet1,savednet2,sn,err1,err2]=trainDeepModel(dataAllsignals,SomeFeatures,yTrain,typesAll,patientsAll,typeOrO,learnRate)
maxVal=1e3;divMax=0;
% switch nargin
%     case 4
%         learnRate=1e-2/2;
%         typeOrO=0;
%     case 5
%         learnRate=1e-2/2;
% end
switch nargin
    case 5
        learnRate=1e-2/2;
        typeOrO=0;
    case 6
        learnRate=1e-2/2;
end
% midvVecsO=[12 6 3 1];%s
% midvVecsO=[6 4  2 1];
% midvVecs=[4 2 1];
if typeOrO==0
   midvVecs=[4 2 1];
else
    midvVecs=[12 6 3 1];
end
Nq=4;
dropRate=0.25;
SomeFeatures=[SomeFeatures,typesAll];
% meanDataSignals=mean(dataAllsignals);
% stdDataSignals=std(dataAllsignals,1);
% dataAllsignals = (dataAllsignals-meanDataSignals)./stdDataSignals;
% layersNewCombinedMLP_Imp
N = Nq*1e4;
Fs=1000;
miniBatchSizes=[128];
coeff1=10;
dataAllsignalsMat=zeros(length(dataAllsignals),N);
trainSize=length(dataAllsignals);
for i=1:length(dataAllsignals)
    cfeature=dataAllsignals{i};
    if length(cfeature)<N
        cfeature=[cfeature;cfeature];
        while length(cfeature)<N
            cfeature=[cfeature;cfeature];
        end
    end
    dataAllsignalsMat(i,:)=cfeature(1:N);
end
meanDataSignals=mean(dataAllsignalsMat);
stdDataSignals=std(dataAllsignalsMat,1)+1e-10;
dataAllsignalsMat = (dataAllsignalsMat-meanDataSignals)./stdDataSignals;
% watch out in testing
sn = waveletScattering('SignalLength',N,'InvarianceScale',N,'OptimizePath',true,'QualityFactors',midvVecs);
% snO = waveletScattering('SignalLength',N,'InvarianceScale',N,'OptimizePath',true,'QualityFactors',midvVecsO);
scat_features = cell(trainSize,1);
% scat_features_O = cell(trainSize,1);

% featuresAll
tmp = featureMatrix(sn,dataAllsignalsMat(1:round(end/2),:)')*coeff1;
for itr=1:round(trainSize/2)
    scat_features{itr,1} =tmp(:,:,itr);
end
tmp = featureMatrix(sn,dataAllsignalsMat(round(end/2)+1:end,:)')*coeff1;
for itr=round(trainSize/2)+1:trainSize
    scat_features{itr,1} =tmp(:,:,itr-round(trainSize/2));
end

% tmp = featureMatrix(snO,dataAllsignalsMat(1:round(end/2),:)')*coeff1;
% for itr=1:round(trainSize/2)
%     scat_features_O{itr,1} =tmp(:,:,itr);
% end
% tmp = featureMatrix(snO,dataAllsignalsMat(1:round(end/2),:)')*coeff1;
% for itr=round(trainSize/2)+1:trainSize
%     scat_features_O{itr,1} =tmp(:,:,itr-round(trainSize/2));
% end
clear tmp;
[inputSize,~] = size(scat_features{1});
% [inputSizeO,~] = size(scat_features_O{1});
% scat_features_train1 = cell(trainSize,1);
dlnet = layersNewCombined_with_MLP(inputSize,dropRate);
% dlnetA = layersNewCombined_without_MLP(inputSize,dropRate);
% dlnetO = layersNewCombined_with_MLP(inputSizeO,dropRate);
% dlnetOA = layersNewCombined_without_MLP(inputSizeO,dropRate);
% layersNewCombined_without_MLP(inputSize,dropRate,regSize);
% layersNewCombinedMLP_Imp(normType,iWeights);
SomeFeatures(isinf(SomeFeatures))=maxVal;
SomeFeatures(SomeFeatures>maxVal)=maxVal;
SomeFeatures(isnan(SomeFeatures))=0;

scat_features_trainArray=zeros(inputSize,size(scat_features{1},2),length(scat_features));
for i=1:size(scat_features_trainArray,3)
    scat_features_trainArray(:,:,i)=scat_features{i};
end
maxSomeFeatures=max(abs(SomeFeatures));
SomeFeatures(isnan(SomeFeatures))=0;

patientsAllu=unique(patientsAll);
valSet1=1:5:length(patientsAllu);
patientsAlluVal1=patientsAllu(valSet1);
valSet1i=[];
for i=1:length(patientsAll)
    if ismember(patientsAll(i),patientsAlluVal1)
        valSet1i=[valSet1i,i];
    end
end
if length(valSet1i)>=512
valSet1i=valSet1i(1:512);
else
    valSet1i=valSet1i(1:256);
end


valSet2=2:5:length(patientsAllu);
patientsAlluVal2=patientsAllu(valSet2);
valSet2i=[];
for i=1:length(patientsAll)
    if ismember(patientsAll(i),patientsAlluVal2)
        valSet2i=[valSet2i,i];
    end
end
if length(valSet2i)>=512
valSet2i=valSet2i(1:512);
else
    valSet2i=valSet2i(1:256);
end

valSet1=valSet1i;
valSet2=valSet2i;
trainSet1=1:trainSize;trainSet1(valSet1)=[];
trainSet2=1:trainSize;trainSet2(valSet2)=[];
% valSet1=1:12:trainSize;
% valSet2=1:12:trainSize;
% valSet1=[valSet1(1:255),trainSize-1];
% valSet2=[valSet2(1:255),trainSize];
% trainSet1=1:trainSize;trainSet1(valSet1)=[];
% trainSet2=1:trainSize;trainSet2(valSet2)=[];

% trainSet1=1:2:trainSize;
% trainSet2=2:2:trainSize;
% valSet1=trainSet2;
% valSet2=trainSet1;

lval1=length(valSet1);
lval2=length(valSet2);

if rem(length(valSet1),128)>0
    valSet1=[valSet1,valSet1(1:128-rem(length(valSet1),128))];
end

if rem(length(valSet2),128)>0
    valSet2=[valSet2,valSet2(1:128-rem(length(valSet2),128))];
end

scat_features_trainArray1=scat_features_trainArray(:,:,trainSet1);
scat_features_trainArray2=scat_features_trainArray(:,:,trainSet2);
SomeFeatures1=SomeFeatures(trainSet1,:);
SomeFeatures2=SomeFeatures(trainSet2,:);
yTrain1=yTrain(trainSet1);
yTrain2=yTrain(trainSet2);
% oyTrain1=oyTrain(trainSet1);
% oyTrain2=oyTrain(trainSet2);

scat_features_valArray1=scat_features_trainArray(:,:,valSet1);
scat_features_valArray2=scat_features_trainArray(:,:,valSet2);
SomeFeaturesV1=SomeFeatures(valSet1,:);
SomeFeaturesV2=SomeFeatures(valSet2,:);
yVal1=yTrain(valSet1);
yVal2=yTrain(valSet2);
% oyVal1=oyTrain(valSet1);
% oyVal2=oyTrain(valSet2);



dsXTrain1 = arrayDatastore(scat_features_trainArray1,'IterationDimension',3);
dsAnglesTrain1 = arrayDatastore(SomeFeatures1);
YTrain1 = categorical(yTrain1);YTrain1=YTrain1';
YtrainReg1=double(YTrain1)-1;
dsYTrain1 = arrayDatastore(YtrainReg1');
dsTrain1 = combine(dsXTrain1,dsAnglesTrain1,dsYTrain1);

dsXVal1 = arrayDatastore(scat_features_valArray1,'IterationDimension',3);
dsAnglesVal1 = arrayDatastore(SomeFeaturesV1);
YVal1 = categorical(yVal1);YVal1=YVal1';
YvalReg1=double(YVal1)-1;
dsYVal1 = arrayDatastore(YvalReg1');
dsVal1 = combine(dsXVal1,dsAnglesVal1,dsYVal1);

numEpochs = 150;
miniBatchSize = 128;

mbq = minibatchqueue(dsTrain1,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatch,...
    'MiniBatchFormat',{'CTB','CB',''});
iteration = 0;
% Loop over epochs.
losses=[];
averageLosses=[];
valErrors=[];
averageGrad=[];
averageSqGrad=[];
disp('first net')
dlearnRate=learnRate;
dlnet = layersNewCombined_with_MLP(inputSize,dropRate);
for epoch = 1:numEpochs
    dlearnRate=dlearnRate*0.99;
    % Shuffle data.
    shuffle(mbq);
    averageLoss=0;
    siter=0;
    % Loop over mini-batches.
    while hasdata(mbq)
        siter=siter+1;
        iteration = iteration + 1;
        %             if iteration<13
        % Read mini-batch of data.
        [dlX1,dlX2,dlY] = next(mbq);
        
        % Evaluate the model gradients, state, and loss using dlfeval and the
        % modelGradients function and update the network state.
        if size(dlX1,2)==miniBatchSize
            [gradients,state,loss] = dlfeval(@modelGradients,dlnet,dlX1,dlX2,dlY);
            dlnet.State = state;
            
            gradDecay = 0.75;
            sqGradDecay = 0.95;
            % [params,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,learnRate,gradDecay,sqGradDecay);
            %                                                 [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,outputCycles(epoch));
            [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,dlearnRate);
            losses=[losses,double(gather(extractdata(loss)))];
            averageLoss=averageLoss+double(gather(extractdata(loss)));
        end
    end
    averageLoss=averageLoss/siter;
    %validation:
    averageLosses=[averageLosses,averageLoss];
    %                 disp(['averageLosses',num2str(averageLosses)])
    mbqTest = minibatchqueue(dsVal1,...
        'MiniBatchSize',miniBatchSize,...
        'MiniBatchFcn', @preprocessMiniBatch,...
        'MiniBatchFormat',{'CTB','CB',''});
    for i1=1:length(dlnet.State.Value)
        dlnet.State.Value{i1}(:,:)=0;
    end
    [predictions,trueOuts,err] = modelPredictions(dlnet,mbqTest);
    predictions=predictions(1:lval1);
    trueOuts=trueOuts(1:lval1);
    %     disp(err)
    derr=mean(abs(predictions-trueOuts).^2 );
    valErrors=[valErrors,derr];
    [v1,v2]=min(double(gather(extractdata(valErrors))));
    disp([v1,v2,derr,epoch])
    if derr<v1+.001
        savednet1=dlnet;
    end
    if epoch>v2+15
        break;
    end
    if v1>1 && epoch>20
        break;
    end
end
valError1_1=v1;
% savednet1_1=savednet1;
err1=valError1_1;
% mbqTest = minibatchqueue(dsVal1,...
%     'MiniBatchSize',miniBatchSize,...
%     'MiniBatchFcn', @preprocessMiniBatch,...
%     'MiniBatchFormat',{'CTB','CB',''});
% [predictions,trueOuts,err] = modelPredictions(savednet1,mbqTest);
% predictions=predictions(1:lval1);
% trueOuts=trueOuts(1:lval1);
% 
% scoresAllChosenMain=double(gather(extractdata(predictions)));
% 
% dsXTrain1 = arrayDatastore(scat_features_trainArray1,'IterationDimension',3);
% dsAnglesTrain1 = arrayDatastore(SomeFeatures1);
% YTrain1 = categorical(yTrain1);YTrain1=YTrain1';
% YtrainReg1=double(YTrain1)-1;
% dsYTrain1 = arrayDatastore(YtrainReg1');
% dsTrain1 = combine(dsXTrain1,dsAnglesTrain1,dsYTrain1);
% 
% dsXVal1 = arrayDatastore(scat_features_valArray1,'IterationDimension',3);
% dsAnglesVal1 = arrayDatastore(SomeFeaturesV1);
% YVal1 = categorical(yVal1);YVal1=YVal1';
% YvalReg1=double(YVal1)-1;
% dsYVal1 = arrayDatastore(YvalReg1');
% dsVal1 = combine(dsXVal1,dsAnglesVal1,dsYVal1);
% 
% numEpochs = 150;
% miniBatchSize = 128;
% 
% mbq = minibatchqueue(dsTrain1,...
%     'MiniBatchSize',miniBatchSize,...
%     'MiniBatchFcn', @preprocessMiniBatch,...
%     'MiniBatchFormat',{'CTB','CB',''});
% iteration = 0;
% % Loop over epochs.
% losses=[];
% averageLosses=[];
% valErrors=[];
% averageGrad=[];
% averageSqGrad=[];
% disp('first net')
% dlearnRate=learnRate;
% dlnet = layersNewCombined_with_MLP(inputSize,dropRate);
% for epoch = 1:5
%     dlearnRate=dlearnRate*0.99;
%     % Shuffle data.
%     shuffle(mbq);
%     averageLoss=0;
%     siter=0;
%     % Loop over mini-batches.
%     while hasdata(mbq)
%         siter=siter+1;
%         iteration = iteration + 1;
%         %             if iteration<13
%         % Read mini-batch of data.
%         [dlX1,dlX2,dlY] = next(mbq);
%         
%         % Evaluate the model gradients, state, and loss using dlfeval and the
%         % modelGradients function and update the network state.
%         if size(dlX1,2)==miniBatchSize
%             [gradients,state,loss] = dlfeval(@modelGradients,dlnet,dlX1,dlX2,dlY);
%             dlnet.State = state;
%             
%             gradDecay = 0.75;
%             sqGradDecay = 0.95;
%             % [params,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,learnRate,gradDecay,sqGradDecay);
%             %                                                 [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,outputCycles(epoch));
%             [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,dlearnRate);
%             losses=[losses,double(gather(extractdata(loss)))];
%             averageLoss=averageLoss+double(gather(extractdata(loss)));
%         end
%     end
%     averageLoss=averageLoss/siter;
%     %validation:
%     averageLosses=[averageLosses,averageLoss];
%     %                 disp(['averageLosses',num2str(averageLosses)])
%     mbqTest = minibatchqueue(dsVal1,...
%         'MiniBatchSize',miniBatchSize,...
%         'MiniBatchFcn', @preprocessMiniBatch,...
%         'MiniBatchFormat',{'CTB','CB',''});
%     for i1=1:length(dlnet.State.Value)
%         dlnet.State.Value{i1}(:,:)=0;
%     end
%     [predictions,trueOuts,err] = modelPredictions(dlnet,mbqTest);
%     predictions=predictions(1:lval1);
%     trueOuts=trueOuts(1:lval1);
%     %     disp(err)
%     derr=mean(abs(predictions-trueOuts).^2 );
%     valErrors=[valErrors,derr];
%     [v1,v2]=min(double(gather(extractdata(valErrors))));
%     disp([v1,v2,derr,epoch])
%     if derr<v1+.001
%         savednet1=dlnet;
%     end
%     if epoch>v2+15
%         break;
%     end
%     if v1>1 && epoch>20
%         break;
%     end
% end
% valError1_2=v1;
% savednet1_2=savednet1;
% 
% 
% 
% savednet1=savednet1_1;
% err1=valError1_1;
% if valError1_2<valError1_1
%     savednet1=savednet1_2;
%     err1=valError1_2;
% end

% if valError1_3<min([valError1_1,valError1_2])
%     savednet1=savednet1_3;
%     err1=valError1_3;
% end
% if valError1_2<min([valError1_3,valError1_1])
%     savednet1=savednet1_2;
%     err1=valError1_2;
% end

dsXTrain2 = arrayDatastore(scat_features_trainArray2,'IterationDimension',3);
dsAnglesTrain2 = arrayDatastore(SomeFeatures2);
YTrain2 = categorical(yTrain2);YTrain2=YTrain2';
YtrainReg2=double(YTrain2)-1;
dsYTrain2 = arrayDatastore(YtrainReg2');
dsTrain2 = combine(dsXTrain2,dsAnglesTrain2,dsYTrain2);

dsXVal2 = arrayDatastore(scat_features_valArray2,'IterationDimension',3);
dsAnglesVal2 = arrayDatastore(SomeFeaturesV2);
YVal2 = categorical(yVal2);YVal2=YVal2';
YvalReg2=double(YVal2)-1;
dsYVal2 = arrayDatastore(YvalReg2');
dsVal2 = combine(dsXVal2,dsAnglesVal2,dsYVal2);

mbq = minibatchqueue(dsTrain2,...
    'MiniBatchSize',miniBatchSize,...
    'MiniBatchFcn', @preprocessMiniBatch,...
    'MiniBatchFormat',{'CTB','CB',''});
iteration = 0;
% Loop over epochs.
losses=[];
averageLosses=[];
valErrors=[];
averageGrad=[];
averageSqGrad=[];
disp('first net')
dlearnRate=learnRate;
dlnet = layersNewCombined_with_MLP(inputSize,dropRate);
for epoch = 1:numEpochs
    dlearnRate=dlearnRate*0.99;
    % Shuffle data.
    shuffle(mbq);
    averageLoss=0;
    siter=0;
    % Loop over mini-batches.
    while hasdata(mbq)
        siter=siter+1;
        iteration = iteration + 1;
        %             if iteration<13
        % Read mini-batch of data.
        [dlX1,dlX2,dlY] = next(mbq);
        
        % Evaluate the model gradients, state, and loss using dlfeval and the
        % modelGradients function and update the network state.
        if size(dlX1,2)==miniBatchSize
            [gradients,state,loss] = dlfeval(@modelGradients,dlnet,dlX1,dlX2,dlY);
            dlnet.State = state;
            
            gradDecay = 0.75;
            sqGradDecay = 0.95;
            % [params,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,learnRate,gradDecay,sqGradDecay);
            %                                                 [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,outputCycles(epoch));
            [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,dlearnRate);
            losses=[losses,double(gather(extractdata(loss)))];
            averageLoss=averageLoss+double(gather(extractdata(loss)));
        end
    end
    averageLoss=averageLoss/siter;
    %validation:
    averageLosses=[averageLosses,averageLoss];
    %                 disp(['averageLosses',num2str(averageLosses)])
    mbqTest = minibatchqueue(dsVal2,...
        'MiniBatchSize',miniBatchSize,...
        'MiniBatchFcn', @preprocessMiniBatch,...
        'MiniBatchFormat',{'CTB','CB',''});
    for i1=1:length(dlnet.State.Value)
        dlnet.State.Value{i1}(:,:)=0;
    end
    [predictions,trueOuts,err] = modelPredictions(dlnet,mbqTest);
    predictions=predictions(1:lval2);
    trueOuts=trueOuts(1:lval2);
    %     disp(err)
    derr=mean(abs(predictions-trueOuts).^2 );
    valErrors=[valErrors,derr];
    [v1,v2]=min(double(gather(extractdata(valErrors))));
    disp([v1,v2,derr,epoch])
    if derr<v1+.001
        savednet2=dlnet;
    end
    if epoch>v2+15
        break;
    end
    if v1>1 && epoch>20
        break;
    end
end
valError2_1=v1;
% savednet2_1=savednet2;
err2=valError2_1;
% dsXTrain2 = arrayDatastore(scat_features_trainArray2,'IterationDimension',3);
% dsAnglesTrain2 = arrayDatastore(SomeFeatures2);
% YTrain2 = categorical(yTrain2);YTrain2=YTrain2';
% YtrainReg2=double(YTrain2)-1;
% dsYTrain2 = arrayDatastore(YtrainReg2');
% dsTrain2 = combine(dsXTrain2,dsAnglesTrain2,dsYTrain2);
% 
% dsXVal2 = arrayDatastore(scat_features_valArray2,'IterationDimension',3);
% dsAnglesVal2 = arrayDatastore(SomeFeaturesV2);
% YVal2 = categorical(yVal2);YVal2=YVal2';
% YvalReg2=double(YVal2)-1;
% dsYVal2 = arrayDatastore(YvalReg2');
% dsVal2 = combine(dsXVal2,dsAnglesVal2,dsYVal2);
% 
% mbq = minibatchqueue(dsTrain2,...
%     'MiniBatchSize',miniBatchSize,...
%     'MiniBatchFcn', @preprocessMiniBatch,...
%     'MiniBatchFormat',{'CTB','CB',''});
% iteration = 0;
% % Loop over epochs.
% losses=[];
% averageLosses=[];
% valErrors=[];
% averageGrad=[];
% averageSqGrad=[];
% disp('first net')
% dlearnRate=learnRate;
% dlnet = layersNewCombined_with_MLP(inputSize,dropRate);
% for epoch = 1:5
%     dlearnRate=dlearnRate*0.99;
%     % Shuffle data.
%     shuffle(mbq);
%     averageLoss=0;
%     siter=0;
%     % Loop over mini-batches.
%     while hasdata(mbq)
%         siter=siter+1;
%         iteration = iteration + 1;
%         %             if iteration<13
%         % Read mini-batch of data.
%         [dlX1,dlX2,dlY] = next(mbq);
%         
%         % Evaluate the model gradients, state, and loss using dlfeval and the
%         % modelGradients function and update the network state.
%         if size(dlX1,2)==miniBatchSize
%             [gradients,state,loss] = dlfeval(@modelGradients,dlnet,dlX1,dlX2,dlY);
%             dlnet.State = state;
%             
%             gradDecay = 0.75;
%             sqGradDecay = 0.95;
%             % [params,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,learnRate,gradDecay,sqGradDecay);
%             %                                                 [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,outputCycles(epoch));
%             [dlnet,averageGrad,averageSqGrad] = adamupdate(dlnet,gradients,averageGrad,averageSqGrad,iteration,dlearnRate);
%             losses=[losses,double(gather(extractdata(loss)))];
%             averageLoss=averageLoss+double(gather(extractdata(loss)));
%         end
%     end
%     averageLoss=averageLoss/siter;
%     %validation:
%     averageLosses=[averageLosses,averageLoss];
%     %                 disp(['averageLosses',num2str(averageLosses)])
%     mbqTest = minibatchqueue(dsVal2,...
%         'MiniBatchSize',miniBatchSize,...
%         'MiniBatchFcn', @preprocessMiniBatch,...
%         'MiniBatchFormat',{'CTB','CB',''});
%     for i1=1:length(dlnet.State.Value)
%         dlnet.State.Value{i1}(:,:)=0;
%     end
%     [predictions,trueOuts,err] = modelPredictions(dlnet,mbqTest);
%     %     disp(err)
%     predictions=predictions(1:lval2);
%     trueOuts=trueOuts(1:lval2);
%     derr=mean(abs(predictions-trueOuts).^2 );
%     valErrors=[valErrors,derr];
%     [v1,v2]=min(double(gather(extractdata(valErrors))));
%     disp([v1,v2,derr,epoch])
%     if derr<v1+.001
%         savednet2=dlnet;
%     end
%     if epoch>v2+15
%         break;
%     end
%     if v1>1 && epoch>20
%         break;
%     end
% end
% valError2_2=v1;
% savednet2_2=savednet2;
% 
% savednet2=savednet2_1;
% err2=valError2_1;
% if valError2_2<valError2_1
%     savednet2=savednet2_2;
%     err2=valError2_2;
% end
