function val=computeScore(labels,outs)
c_algorithm =     1;
c_expert_1  =   250;
c_expert_2  =   500;
c_treatment =  1000;
c_error     = 10000;
alpha       =   0.5;
num_patients=length(labels);
num_classes=2;
[cm,order] = confusionmat(labels,outs);
A=cm;


n_pp = A(2,2);
n_pu = 0;
n_pn = A(1, 2);
n_up = 0;
n_uu = 0;
n_un = 0;
n_np = A(2, 1);
n_nu = 0;
n_nn = A(1,1);

n_positive = n_pp + n_up + n_np;
n_unknown  = n_pu + n_uu + n_nu;
n_negative = n_pn + n_un + n_nn;

n_total = n_positive + n_unknown + n_negative;

total_score = c_algorithm * n_total ...
    + c_expert_1 * (n_pp + n_pu + n_pn + n_up + n_uu + n_un) ...
    + c_expert_2 * (n_pu + n_uu) ...
    + c_treatment * (n_pp + alpha * n_pu + n_up + alpha * n_uu) ...
    + c_error * (n_np + alpha * n_nu);
val = total_score / n_total;
% if n_total > 0:
%     mean_score = total_score / n_total
% else:
%     mean_score = float('nan')
%
%     return mean_score